"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const custom_1 = __importDefault(require("./custom"));
const helpers_1 = __importDefault(require("./helpers"));
const validate = (value) => {
    const empty = (value || '').trim().length === 0;
    if (empty)
        return false;
    const valida = new Array(6, 5, 4, 3, 2, 9, 8, 7, 6, 5, 4, 3, 2);
    let dig1 = 0;
    let dig2 = 0;
    const exp = /\.|\-|\//g;
    const cnpj = value.toString().replace(exp, '');
    const digito = +eval(cnpj.charAt(12) + cnpj.charAt(13));
    for (let i = 0; i < valida.length; i++) {
        dig1 += i > 0 ? +cnpj.charAt(i - 1) * valida[i] : 0;
        dig2 += +cnpj.charAt(i) * valida[i];
    }
    dig1 = dig1 % 11 < 2 ? 0 : 11 - (dig1 % 11);
    dig2 = dig2 % 11 < 2 ? 0 : 11 - (dig2 % 11);
    return dig1 * 10 + dig2 == digito;
};
const cnpj = {
    validate,
    raw: (value = '') => helpers_1.default.toNumber(value),
    value: (value = '') => custom_1.default.value(value, '99.999.999/9999-99'),
};
exports.default = cnpj;
