"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const custom_1 = __importDefault(require("./custom"));
const helpers_1 = __importDefault(require("./helpers"));
const ZERO_TO_NINE = Array.from({ length: 9 }, (_, i) => i);
const validate = (cpf = '') => {
    try {
        if (!(cpf.length === 14 || cpf.length === 11))
            return false;
        const cpf_number = cpf
            .replace(/\./gi, '')
            .replace(/-/gi, '')
            .split('')
            .map((v) => +v);
        if (ZERO_TO_NINE.some((i) => cpf_number.every((v) => v === i)))
            throw new Error();
        let soma = cpf_number.slice(0, 9).reduce((prev, curr, index) => prev + curr * (10 - index), 0);
        let resto = (soma * 10) % 11;
        if (resto === 10 || resto === 11)
            resto = 0;
        if (resto !== cpf_number[9])
            return false;
        soma = cpf_number.slice(0, 10).reduce((prev, curr, index) => prev + curr * (11 - index), 0);
        resto = (soma * 10) % 11;
        if (resto === 10 || resto === 11)
            resto = 0;
        if (resto !== cpf_number[10])
            return false;
        return true;
    }
    catch (e) {
        return false;
    }
};
const cpf = {
    validate,
    raw: (value = '') => helpers_1.default.toNumber(value),
    value: (value = '') => custom_1.default.value(value, '999.999.999-99'),
};
exports.default = cpf;
